#ifndef	   SIGHT_INFO_ANALYZER_H_INCLUDED
#define	   SIGHT_INFO_ANALYZER_H_INCLUDED

#include  "information_from_server.h"
#include  "d2_vector.h"
#include  "field_state.h"
#include  <vector>
#include  <utility>
#include  <stdexcept>

class  Sight_Info_Analyzer
{
public:
	struct  Object_Coordinate_Info
	{
		D2_Vector	absolute;
		D2_Vector	relative;
	};

	struct  Ball_Player_Coordinate_Info
	{
		bool		recognized;
		D2_Vector	relative;
		D2_Vector	absolute;

		bool		have_vector;
		D2_Vector	relative_vector;
		D2_Vector	absolute_vector;

		Ball_Player_Coordinate_Info()
			: recognized( false ) , have_vector( false )
			{
			}
	};

protected:
	std::vector<Object_Coordinate_Info>	static_obj;
	std::vector<Line_Info_from_Server>	line;

	bool					sorted_by_short_distance;
	std::vector<Object_Coordinate_Info>	obj_sorted_by_short_distance;
	void				require_obj_sorted_by_short_distance();

	bool					have_my_coordinate;
	D2_Vector				my_coordinate;

	bool					have_my_angle;
	double					my_body_angle;
	const double				my_relative_face_angle;
	double					my_absolute_face_angle;

	void					require_my_coordinate()
						    /*throw(std::exception)*/;

	bool					have_ball_player_coordinate;
	Ball_Player_Coordinate_Info		ball_info;
	std::vector<Ball_Player_Coordinate_Info>	teammate_info;
	std::vector<Ball_Player_Coordinate_Info>	opponent_info;
	void					require_ball_player_coordinate
						  () /*throw(std::exception)*/;
	void	set_flag_goal_info( const Sight_Info_from_Server &  sight );
	void	set_line_info( const Sight_Info_from_Server &  sight );
	void	set_ball_info( const Sight_Info_from_Server &  sight );
	void	set_player_info( const Sight_Info_from_Server &  sight );

public:
	 Sight_Info_Analyzer( const Sight_Info_from_Server &  sight ,
			      double  relative_face_angle = 0.0 );
	~Sight_Info_Analyzer();

	Field_State		get_field_state( int  my_player_number )
					/*throw(std::exception)*/;

	size_t			n_objects() throw();
	size_t			n_lines() throw();

	void			get_my_coordinate( D2_Vector *  vec ,
						   double *  ang )
						/*throw(std::exception)*/;

	void			get_ball_coordinate( D2_Vector *  vec )
						/*throw(std::exception)*/;

	void			get_player_coordinate( S_Side  side ,
						       int player_number ,
						       D2_Vector *  vec )
						/*throw(std::exception)*/;


	double			get_my_angle_from_line()
						/*throw(std::exception)*/;

	D2_Vector		get_my_coordinate_by_angle_and_two_point(
				      double  angle ,
				      const Object_Coordinate_Info &  obj_1 ,
				      const Object_Coordinate_Info &  obj_2 );

	std::pair<Sight_Info_Analyzer::Object_Coordinate_Info ,
		  Sight_Info_Analyzer::Object_Coordinate_Info>
				get_differ_angle_two_objs();
};


#endif	/* SIGHT_INFO_ANALYZER_H_INCLUDED */
