#include  "information_from_server.h"

//
// Information_from_Server
//
Information_from_Server::Information_from_Server()
	: initialized() ,
	  type_of_info( Type_Unknown ) ,
	  time_of_info( 0 ) ,
	  raw_mes() ,
	  sight  ( NULL ) ,
	  audio  ( NULL ) ,
	  whistle( NULL ) ,
	  body   ( NULL ) ,
	  err    ( NULL ) ,
	  debug  ( NULL )
{
	initialized.true_or_false = true;
}


Information_from_Server::Information_from_Server(
				const Information_from_Server &  info )
	: initialized() ,
	  type_of_info( Type_Unknown ) ,
	  time_of_info( 0 ) ,
	  raw_mes() ,
	  sight  ( NULL ) ,
	  audio  ( NULL ) ,
	  whistle( NULL ) ,
	  body   ( NULL ) ,
	  err    ( NULL ) ,
	  debug  ( NULL )
{
	initialized.true_or_false = true;

	operator=( info );
}


Information_from_Server::~Information_from_Server()
{
	reset_info();
}


Information_from_Server &  Information_from_Server::operator= (
					const Information_from_Server &  info )
{
	if ( initialized.true_or_false == false )
	{
		type_of_info = Type_Unknown;

		time_of_info = 0;

		sight   = NULL;
		audio   = NULL;
		whistle = NULL;
		body    = NULL;
		err     = NULL;
		debug   = NULL;

		initialized.true_or_false = true;
	}

	reset_info();

	type_of_info = info.type_of_info;
	time_of_info = info.time_of_info;
	raw_mes      = info.raw_mes;

	if ( info.sight  !=  NULL )
	{
		sight = new Sight_Info_from_Server( *(info.sight) );
#ifdef DEBUG
		cerr << "new Sight_Info_from_Server " << (void*)sight << endl;
#endif
	}
	else if ( info.audio  !=  NULL )
	{
		audio = new Audio_Info_from_Server( (*info.audio) );
#ifdef DEBUG
		cerr << "new Audio_Info_from_Server " << (void*)audio << endl;
#endif
	}
	else if ( info.whistle  !=  NULL )
	{
		whistle = new Whistle_Info_from_Server( *(info.whistle) );
#ifdef DEBUG
		cerr << "new Whistle_Info_from_Server " << (void*)whistle
		     << endl;
#endif
	}
	else if ( info.body  !=  NULL )
	{
		body = new Body_Info_from_Server( *(info.body) );
#ifdef DEBUG
		cerr << "new Body_Info_from_Server " << (void*)body << endl;
#endif
	}
	else if ( info.err  !=  NULL )
	{
		err = new Error_Info_from_Server( *(info.err) );
#ifdef DEBUG
		cerr << "new Error_Info_from_Server " << (void*)err << endl;
#endif
	}
	else if ( info.debug  !=  NULL )
	{
		debug = new Debug_Info_from_Server( *(info.debug) );
#ifdef DEBUG
		cerr << "new Debug_Info_from_Server " << (void*)debug << endl;
#endif
	}

	return( *this );
}


void   Information_from_Server::reset_info()
{
	type_of_info = Type_Unknown;

#ifdef DEBUG
	if ( sight )
	{
		cerr << "delete sight " << (void*)sight << endl;
	}
	if ( audio )
	{
		cerr << "delete audio " << (void*)audio << endl;
	}
	if ( whistle )
	{
		cerr << "delete whistle " << (void*)whistle << endl;
	}
	if ( body )
	{
		cerr << "delete body" << (void*)body << endl;
	}
	if ( err )
	{
		cerr << "delete error" << (void*)err << endl;
	}
	if ( debug )
	{
		cerr << "delete debug" << (void*)debug << endl;
	}
#endif

	delete  sight;
	delete  audio;
	delete  whistle;
	delete  body;
	delete  err;
	delete  debug;

	sight   = NULL;
	audio   = NULL;
	whistle = NULL;
	body    = NULL;
	err     = NULL;
	debug   = NULL;
}


void   Information_from_Server::set_raw_message( const string &  mes )
{
	this ->  raw_mes = mes;
}


void   Information_from_Server::set_time( int  t )
{
	time_of_info = t;
}


void   Information_from_Server::set_info( const Sight_Info_from_Server &  si )
{
	reset_info();
	this ->  type_of_info = Type_Sight;
	this ->  sight = new Sight_Info_from_Server( si );
#ifdef DEBUG
	cerr << "new #Sight_Info_from_Server " << (void*)sight << endl;
#endif
}


void   Information_from_Server::set_info( const Audio_Info_from_Server &  au )
{
	reset_info();
	this ->  type_of_info = Type_Audio;
	this ->  audio = new Audio_Info_from_Server( au );
#ifdef DEBUG
		cerr << "new #Audio_Info_from_Server " << (void*)audio << endl;
#endif
}


void   Information_from_Server::set_info(
				const Whistle_Info_from_Server &  wi )
{
	reset_info();
	this ->  type_of_info = Type_Whistle;
	this ->  whistle = new Whistle_Info_from_Server( wi );
#ifdef DEBUG
		cerr << "new #Whistle_Info_from_Server " << (void*)whistle
		     << endl;
#endif
}


void   Information_from_Server::set_info( const Body_Info_from_Server &  bd )
{
	reset_info();
	this ->  type_of_info = Type_Body;
	this ->  body = new Body_Info_from_Server( bd );
#ifdef DEBUG
	cerr << "new #Body_Info_from_Server " << (void*)body << endl;
#endif
}


void   Information_from_Server::set_info( const Error_Info_from_Server &  er )
{
	reset_info();
	this ->  type_of_info = Type_Error;
	this ->  err = new Error_Info_from_Server( er );
#ifdef DEBUG
	cerr << "new #Error_Info_from_Server " << (void*)err << endl;
#endif
}

void   Information_from_Server::set_info( const Debug_Info_from_Server &  de )
{
	reset_info();
	this ->  type_of_info = Type_Debug;
	this ->  debug = new Debug_Info_from_Server( de );
#ifdef DEBUG
	cerr << "new #Debug_Info_from_Server " << (void*)debug << endl;
#endif
}


void   Information_from_Server::set_no_info()
{
	reset_info();
	this ->  type_of_info = Type_No_Info;
}




string  Information_from_Server::raw_message() const
{
	return( raw_mes );
}


Information_from_Server::Info_Type  Information_from_Server::type() const
{
	return( this ->  type_of_info );
}


int    Information_from_Server::time() const
{
	return( this ->  time_of_info );
}


bool   Information_from_Server::illegal() const
{
	return( this ->  type_of_info  ==  Type_Unknown );
}


bool   Information_from_Server::no_info() const
{
	return( this ->  type_of_info  ==  Type_No_Info );
}


Sight_Info_from_Server  Information_from_Server::get_sight_info() const
{
	if ( sight != NULL )
	{
		return( *sight );
	}
	else
	{
		Sight_Info_from_Server	ret;
		return( ret );
	}
}


Audio_Info_from_Server  Information_from_Server::get_audio_info() const
{
	if ( audio != NULL )
	{
		return( *audio );
	}
	else
	{
		Audio_Info_from_Server	ret;
		return( ret );
	}
}


Whistle_Info_from_Server  Information_from_Server::get_whistle_info() const
{
	if ( whistle != NULL )
	{
		return( *whistle );
	}
	else
	{
		Whistle_Info_from_Server	ret;
		return( ret );
	}
}


Body_Info_from_Server  Information_from_Server::get_body_info() const
{
	if ( body != NULL )
	{
		return( *body );
	}
	else
	{
		Body_Info_from_Server	ret;
		return( ret );
	}
}


Error_Info_from_Server  Information_from_Server::get_error_info() const
{
	if ( err != NULL )
	{
		return( *err );
	}
	else
	{
		Error_Info_from_Server	ret;
		return( ret );
	}
}


Debug_Info_from_Server  Information_from_Server::get_debug_info() const
{
	if ( debug != NULL )
	{
		return( *debug );
	}
	else
	{
		Debug_Info_from_Server	ret;
		return( ret );
	}
}
