#include  "sserver_param.h"
#include  "dig_rad.h"
#include  <cmath>

using namespace std;

const	int	SServer_Param::SSERVER_DEFAULT_PORT = 6000;

const	double	SServer_Param::DEFAULT_BALL_SIZE = 0.085;
const	double	SServer_Param::DEFAULT_PLAYER_SIZE = 0.3;
const	double	SServer_Param::DEFAULT_PLAYER_SPEED_MAX = 1.0;

const	double	SServer_Param::DEFAULT_BALL_DECAY = 0.94;
const	double	SServer_Param::DEFAULT_PLAYER_DECAY = 0.4;
const	double	SServer_Param::DEFAULT_DASH_POWER_RATE = 0.006;
const	double	SServer_Param::DEFAULT_KICK_POWER_RATE = 0.016;

const	double	SServer_Param::DEFAULT_BALL_SPEED_MAX = 2.7;

const	double	SServer_Param::DEFAULT_CATCHABLE_AREA_L = 2.0;
const	double	SServer_Param::DEFAULT_CATCHABLE_AREA_W = 1.0;
const	int	SServer_Param::DEFAULT_CATCH_BAN_CYCLE = 5;

const	double	SServer_Param::DEFAULT_KICKABLE_MARGIN = 0.7;

const	double	SServer_Param::DEFAULT_STAMINA_MAX = 3500;

const	double	SServer_Param::DEFAULT_STAMINA_INC_MAX = 35.0;

const	size_t	SServer_Param::DEFAULT_SAY_MESSAGE_LENGTH = 2048;

const	double	SServer_Param::DEFAULT_MAX_POWER = (+ 100.0);
const	double	SServer_Param::DEFAULT_MIN_POWER = (- 100.0);

const	double	SServer_Param::DEFAULT_MAX_MOMENT = (+ 180.0);
const	double	SServer_Param::DEFAULT_MIN_MOMENT = (- 180.0);

const	double	SServer_Param::DEFAULT_INERTIA_MOMENT = 5.0;

const	int	SServer_Param::DEFAULT_RECV_STEP = 10; // msec

const	double	SServer_Param::DEFAULT_SHORT_SENSOR_LENGTH = 3.0;

const	double	SServer_Param::DEFAULT_MAX_NECK_MOMENT =  180.0;
const	double	SServer_Param::DEFAULT_MIN_NECK_MOMENT = -180.0;
const	double	SServer_Param::DEFAULT_MAX_NECK_ANGLE  = dig_to_rad(  90.0 );
const	double	SServer_Param::DEFAULT_MIN_NECK_ANGLE  = dig_to_rad( -90.0 );

const	double	SServer_Param::DEFAULT_HALF_TIME = 300; // sec
const	double	SServer_Param::DEFAULT_SIMULATOR_STEP = 100; // msec


SServer_Param::SServer_Param() throw()
{
}

SServer_Param::~SServer_Param() throw()
{
}


double  SServer_Param::BALL_SIZE() const throw()
{
	return( DEFAULT_BALL_SIZE );
}

double  SServer_Param::PLAYER_SIZE() const throw()
{
	return( DEFAULT_PLAYER_SIZE );
}

double  SServer_Param::PLAYER_SPEED_MAX() const throw()
{
	return( DEFAULT_PLAYER_SPEED_MAX );
}

double  SServer_Param::BALL_DECAY() const throw()
{
	return( DEFAULT_BALL_DECAY );
}

double  SServer_Param::PLAYER_DECAY() const throw()
{
	return( DEFAULT_PLAYER_DECAY );
}

double  SServer_Param::DASH_POWER_RATE() const throw()
{
	return( DEFAULT_DASH_POWER_RATE );
}

double  SServer_Param::KICK_POWER_RATE() const throw()
{
	return( DEFAULT_KICK_POWER_RATE );
}

double  SServer_Param::BALL_SPEED_MAX() const throw()
{
	return( DEFAULT_BALL_SPEED_MAX );
}

double  SServer_Param::CATCHABLE_AREA_L() const throw()
{
	return( DEFAULT_CATCHABLE_AREA_L );
}

double  SServer_Param::CATCHABLE_AREA_W() const throw()
{
	return( DEFAULT_CATCHABLE_AREA_W );
}

int     SServer_Param::CATCH_BAN_CYCLE() const throw()
{
	return( DEFAULT_CATCH_BAN_CYCLE );
}

double  SServer_Param::KICKABLE_MARGIN() const throw()
{
	return( DEFAULT_KICKABLE_MARGIN );
}

double  SServer_Param::STAMINA_MAX() const throw()
{
	return( DEFAULT_STAMINA_MAX );
}

double  SServer_Param::STAMINA_INC_MAX() const throw()
{
	return( DEFAULT_STAMINA_INC_MAX );
}

size_t  SServer_Param::SAY_MESSAGE_LENGTH() const throw()
{
	return( DEFAULT_SAY_MESSAGE_LENGTH );
}

double  SServer_Param::MAX_POWER() const throw()
{
	return( DEFAULT_MAX_POWER );
}

double  SServer_Param::MIN_POWER() const throw()
{
	return( DEFAULT_MIN_POWER );
}

double  SServer_Param::MAX_MOMENT() const throw()
{
	return( DEFAULT_MAX_MOMENT );
}

double  SServer_Param::MIN_MOMENT() const throw()
{
	return( DEFAULT_MIN_MOMENT );
}

double  SServer_Param::INERTIA_MOMENT() const throw()
{
	return( DEFAULT_INERTIA_MOMENT );
}

int     SServer_Param::RECV_STEP() const throw()
{
	return( DEFAULT_RECV_STEP );
}


double  SServer_Param::SHORT_SENSOR_LENGTH() const throw()
{
	return( DEFAULT_SHORT_SENSOR_LENGTH );
}

double  SServer_Param::MAX_NECK_MOMENT() const throw()
{
	return( DEFAULT_MAX_NECK_MOMENT );
}

double  SServer_Param::MIN_NECK_MOMENT() const throw()
{
	return( DEFAULT_MIN_NECK_MOMENT );
}

double  SServer_Param::MAX_NECK_ANGLE() const throw()
{
	return( DEFAULT_MAX_NECK_ANGLE );
}

double  SServer_Param::MIN_NECK_ANGLE() const throw()
{
	return( DEFAULT_MIN_NECK_ANGLE );
}

double  SServer_Param::HALF_TIME() const throw()
{
	return( DEFAULT_HALF_TIME );
}

double  SServer_Param::SIMULATOR_STEP() const throw()
{
	return( DEFAULT_SIMULATOR_STEP );
}




double  SServer_Param::half_time_step() const throw()
{
	if ( this -> SIMULATOR_STEP() == 0 )
	{
		return( 0 );
	}

	return( this -> HALF_TIME() * 1000
		/ this -> SIMULATOR_STEP() );
}


double  SServer_Param::field_half_length() const throw()
{
	return( 52.5 );
}

double  SServer_Param::field_length() const throw()
{
	return( this -> field_half_length() * 2.0 );
}

double  SServer_Param::field_half_width() const throw()
{
	return( 34.0 );
}

double  SServer_Param::field_width() const throw()
{
	return( this -> field_half_width() * 2.0 );
}

double  SServer_Param::field_diagonal() const throw()
{
	return( sqrt(   pow( this -> field_length() , 2.0 )
		      + pow( this -> field_width() , 2.0 ) ) );
}




D2_Vector  SServer_Param::initial_position( S_Side_LR  side ,
					    int  player_number )
	const throw()
{
	double	x = - player_number * 3.0;
	double	y = ((side == S_Side_LR::Left_Side) ? 1.0 : -1.0)
		    * (- this -> field_half_width() - 3.0 );

	return( D2_Vector( x , y ) );
}


double  SServer_Param::kickable_distance() const throw()
{
	return( BALL_SIZE() + KICKABLE_MARGIN() + PLAYER_SIZE() );
}

double  SServer_Param::catchable_length() const throw()
{
	return( this -> CATCHABLE_AREA_L() );
}

double  SServer_Param::catchable_width() const throw()
{
	return( this -> CATCHABLE_AREA_W() );
}

double  SServer_Param::catchable_half_width() const throw()
{
	return( this -> CATCHABLE_AREA_W() / 2.0 );
}

double  SServer_Param::catchable_diagona_distance() const throw()
{
	double	len = this -> catchable_length();
	double	wid = this -> catchable_half_width();

	double	length_2 = pow( len , 2.0 ) + pow( wid , 2.0 );
	if ( length_2 < 0.0 )
	{
		length_2 = 0.0;
	}

	double	length = sqrt( length_2 );

	return( length );
}




D2_Vector  SServer_Param::ball_basic_point_n_turn_later
				( const D2_Vector &  current_point ,
				  const D2_Vector &  vec ,
				  int  n ) const throw()
{
#if 0
	if ( n == 0 )
	{
		return( current_point );
	}
	else // if ( n > 0 )
	{
		return( this -> ball_basic_point_n_turn_later
					( current_point ,
					  vec * this -> BALL_DECAY() ,
					  n - 1 )
			+ vec );
	}
# if 0
	else // if ( n < 0 )
	{
	}
# endif
#else
	return( current_point
		+ vec * ( (1.0 - pow( this -> BALL_DECAY() , n ))
		          / (1.0 - this -> BALL_DECAY()) ) );
#endif
}

D2_Vector  SServer_Param::player_basic_point_n_turn_later
					( const D2_Vector &  current_point ,
					  const D2_Vector &  vec ,
					  int  n ) const throw()
{
#if 0
	if ( n == 0 )
	{
		return( current_point );
	}
	else // if ( n > 0 )
	{
		return( this -> player_basic_point_n_turn_later
					( current_point ,
					  vec * this -> PLAYER_DECAY() ,
					  n - 1 )
			+ vec );
	}
# if 0
	else // if ( n < 0 )
	{
	}
# endif
#else
	return( current_point
		+ vec * ( (1.0 - pow( this -> PLAYER_DECAY() , n ))
		          / (1.0 - this -> PLAYER_DECAY()) ) );
#endif
}

double  SServer_Param::how_much_dash_power_to_reach_next_turn( double  dist )
	const throw()
{
	return( dist / this -> DASH_POWER_RATE() );
}

double  SServer_Param::player_stop_power( double  current_speed ) const throw()
{
	double	power = - current_speed / (this -> DASH_POWER_RATE());

	if ( power < (this -> MIN_POWER()) )
	{
		power = this -> MIN_POWER();
	}

	if ( power > (this -> MAX_POWER()) )
	{
		power = this -> MAX_POWER();
	}

	return( power );
}

double  SServer_Param::dash_power_to_accel( double  dash_power ) const throw()
{
	return( dash_power * (this -> DASH_POWER_RATE()) );
}

double  SServer_Param::actual_moment( double  dir ,  double  my_speed ,
				      bool *  succeeded ) const throw()
{
	try
	{
		const	double	EPS = 0.001;
		const	double	eps = dig_to_rad( EPS );

		double	moment
			= normalize_angle( dir )
			  * ( 1.0 + this -> INERTIA_MOMENT() * my_speed );

		if ( succeeded )
		{
			*succeeded = true;
		}

		if ( moment > dig_to_rad( this -> MAX_MOMENT() - eps ) )
		{
			if ( succeeded )
			{
				*succeeded = false;
			}

			moment = dig_to_rad( this -> MAX_MOMENT() - eps );
		}
		else if ( moment < dig_to_rad( this -> MIN_MOMENT() + eps ) )
		{
			if ( succeeded )
			{
				*succeeded = false;
			}

			moment = dig_to_rad( this -> MIN_MOMENT() + eps );
		}

		return( moment );
	}
	catch(...)
	{
		if ( succeeded )
		{
			*succeeded = false;
		}

		return( 0.0 );
	}
}

double  SServer_Param::turn_moment_to_angle( double  moment ,
					     double  my_speed ) const throw()
{
	double	m = moment;

	if ( m > dig_to_rad( this -> MAX_MOMENT() ) )
	{
		m = dig_to_rad( this -> MAX_MOMENT() );
	}
	else if ( m < dig_to_rad( this -> MIN_MOMENT() ) )
	{
		m = dig_to_rad( this -> MIN_MOMENT() );
	}

	return( m / ( 1.0 + this -> INERTIA_MOMENT() * my_speed ) );
}


double  SServer_Param::kick_accel_to_power( double  accel ,
					    double  ball_dist ,
					    double  ball_dir ,
					    bool *  succeeded )
	const throw()
{
	if ( succeeded )
	{
		*succeeded = true;
	}

	if ( ball_dist < (this -> PLAYER_SIZE()) )
	{
		ball_dist = this -> PLAYER_SIZE() + this -> BALL_SIZE();
	}

	double	power = accel
			/ this -> KICK_POWER_RATE()
			/ (1.0 - 0.25 * ( fabs( ball_dir ) / M_PI )
			       - 0.25 * ( (ball_dist - this -> PLAYER_SIZE()
						     - this -> BALL_SIZE() )
					  / this -> KICKABLE_MARGIN() ));

	if ( power > this -> MAX_POWER() )
	{
		power = this -> MAX_POWER();

		if( succeeded )
		{
			*succeeded = false;
		}
	}
	else if ( power < this -> MIN_POWER() )
	{
		power = this -> MIN_POWER();

		if( succeeded )
		{
			*succeeded = false;
		}
	}

	return( power );
}

double  SServer_Param::kick_power_to_accel( double  power ,
					    double  ball_dist ,
					    double  ball_dir ) const throw()
{
	if ( ball_dist < (this -> PLAYER_SIZE()) )
	{
		ball_dist = this -> PLAYER_SIZE() + this -> BALL_SIZE();
	}

	double	accel = power
			* this -> KICK_POWER_RATE()
			* (1.0 - 0.25 * ( fabs( ball_dir ) / M_PI )
			       - 0.25 * ( (ball_dist - this -> PLAYER_SIZE()
						     - this -> BALL_SIZE() )
					  / this -> KICKABLE_MARGIN() ));
	return( accel );
}
