#include <libCMU.h>
#include <zeng.h>

int dance_counter ;
int move_counter ;
int say_counter ;

void (*behaves[12])(void) = {
	NULL,				// Unum
	//tmp
	SW_behave,			// 1

	//tmp
	DF_behave,			// 2
	DF_behave,			// 3
	DF_behave,			// 4

	//main
	RMF_behave,			// 5
	LMF_behave,			// 6
	LSMF_behave,			// 7
	RSMF_behave,			// 8

	//tmp
	OH_behave,			// 9
	LFW_behave,			// 10
	RFW_behave,			// 11
};

//tmp
static double offside_line_value[12] = {
	10.0,

	10.0,

	10.0,
	10.0,
	10.0,

	15.0,
	15.0,

	15.0,
	15.0,

	15.0,

	10.0,
	10.0,
} ;

static double init_pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{-48.0	,  0.0	},/*C  GK*//*1*/

{-15.0	,  0.0	},/*C  DF*//*2*/
{-15.0	,-16.0	},/*L  DF*//*3*/
{-15.0	, 16.0	},/*R  DF*//*4*/

{ -9.0	,  9.0	},/*R  MF*//*5*/
{ -9.0	, -9.0	},/*L  MF*//*6*/

{ -2.0	,-25.0	},/*L SMF*//*7*/
{ -2.0	, 25.0	},/*R SMF*//*8*/

{ -5.0	,  0.0	},/*C  OH*//*9*/
{-10.0	,-16.0	},/*R  FW*//*10*/
{-10.0	, 16.0	},/*L  FW*//*11*/
};

static double init_pos2[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{-48.0	,  0.0	},/*C  GK*//*1*/

{-15.0	,  0.0	},/*C  DF*//*2*/
{-15.0	,-20.0	},/*L  DF*//*3*/
{-15.0	, 20.0	},/*R  DF*//*4*/

{-10.0	,  9.0	},/*R  MF*//*5*/
{-10.0	, -9.0	},/*L  MF*//*6*/

{-10.0	,-20.0	},/*L SMF*//*7*/
{-10.0	, 20.0	},/*R SMF*//*8*/

{-10.0	,  0.0	},/*C  OH*//*0*/
{-10.0	,-16.0	},/*R  FW*//*0*/
{-10.0	, 16.0	},/*L  FW*//*0*/
};

static double pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{-48.0	,  0.0	},/*C  GK*//*1*/

{-12.0	,  0.0	},/*C  DF*//*2*/
{-12.0	,-16.0	},/*L  DF*//*3*/
{-12.0	, 16.0	},/*R  DF*//*4*/

{ 10.0	, 10.0	},/*R  MF*//*5*/
{ 10.0	,-10.0	},/*L  MF*//*6*/

{-10.0	,-25.0	},/*L SMF*//*7*/
{-10.0	, 25.0	},/*R SMF*//*8*/

{ 13.0	,  0.0	},/*C  OH*//*0*/
{ 15.0	,-12.0	},/*R  FW*//*0*/
{ 15.0	, 12.0	},/*L  FW*//*0*/
} ;

static double pos2[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{-48.0	,  0.0	},/*C  GK*//*1*/

{ -5.0	,  0.0	},/*C  DF*//*2*/
{ -5.0	,-18.0	},/*L  DF*//*3*/
{ -5.0	, 18.0	},/*R  DF*//*4*/

{  0.0	, 10.0	},/*R  MF*//*5*/
{  0.0	,-10.0	},/*L  MF*//*6*/

{-10.0	,-25.0	},/*L SMF*//*7*/
{-10.0	, 25.0	},/*R SMF*//*8*/

{ 10.0	,  0.0	},/*C  OH*//*0*/
{ 15.0	,-12.0	},/*R  FW*//*0*/
{ 15.0	, 12.0	},/*L  FW*//*0*/
} ;

static double offside_line_offset_set[12] = {
  0.0	,/*dummy*//*0*/
  0.0	,/*C  GK*//*1*/

 40.0	,/*C  DF*//*2*/
 40.0	,/*L  DF*//*3*/
 40.0	,/*R  DF*//*4*/

 20.0	,/*R  MF*//*5*/
 20.0	,/*L  MF*//*6*/

 10.0	,/*L SMF*//*7*/
 10.0	,/*R SMF*//*8*/

 10.0	,/*C  OH*//*0*/
  5.0	,/*R  FW*//*0*/
  5.0	,/*L  FW*//*0*/
} ;

static double shoot_distance_set[12] = {
  0.0	,/*dummy*//*0*/
  0.0	,/*C  GK*//*1*/

  0.0	,/*C  DF*//*2*/
  0.0	,/*L  DF*//*3*/
  0.0	,/*R  DF*//*4*/

 20.0	,/*R  MF*//*5*/
 20.0	,/*L  MF*//*6*/

 22.0	,/*L SMF*//*7*/
 22.0	,/*R SMF*//*8*/

 25.0	,/*C  OH*//*0*/
 25.0	,/*R  FW*//*0*/
 25.0	,/*L  FW*//*0*/
} ;


Property *MyProp;

void my_init()
{
  say_counter = 0 ;
  dance_counter = 0 ;
  move_counter= 0 ;

  MyProp = new Property();

  if ( Mem->CP_role < 1 || Mem-> CP_role > 11 )
  {
	  Mem->CP_role = 1 ;
  }

  MyProp->my_behave = behaves[Mem->CP_role];
  {
    Vector v(init_pos[Mem->CP_role][0], init_pos[Mem->CP_role][1]);
    MyProp->init_pos = v;
    Vector v2(init_pos2[Mem->CP_role][0], init_pos2[Mem->CP_role][1]);
    MyProp->init_pos2 = v2;
  }

  {
    Vector v(pos[Mem->CP_role][0], pos[Mem->CP_role][1]);
    MyProp->pos = v;

    Vector v2(pos2[Mem->CP_role][0], pos2[Mem->CP_role][1]);
    MyProp->pos2 = v2;
  }

  MyProp->beforekickoff
	  = get_position_beforekickoff ( Mem->CP_role ) ; 
  MyProp->my_kickoff
	  = get_position_my_kickoff ( Mem->CP_role ) ;    
  MyProp->their_kickoff
	  = get_position_their_kickoff ( Mem->CP_role ) ; 
  MyProp->my_kickin
	  = get_position_my_kickin ( Mem->CP_role ) ;     
  MyProp->their_kickin
	  = get_position_their_kickin ( Mem->CP_role ) ;  
  MyProp->my_freekick
	  = get_position_my_freekick ( Mem->CP_role ) ;   
  MyProp->their_freekick
	  = get_position_their_freekick ( Mem->CP_role ) ;
  MyProp->my_offsidekick
	  = get_position_my_offside ( Mem->CP_role ) ;    
  MyProp->their_offsidekick
	  = get_position_their_offside ( Mem->CP_role ) ; 
  MyProp->my_cornerkick
	  = get_position_my_cornerkick ( Mem->CP_role ) ; 
  MyProp->their_cornerkick
	  = get_position_their_cornerkick ( Mem->CP_role ) ;
  MyProp->my_goalkick
	  = get_position_my_goalkick ( Mem->CP_role ) ;   
  MyProp->their_goalkick
	  = get_position_their_goalkick ( Mem->CP_role ) ;

  MyProp->my_freekick_point
	  = get_position_my_freekick_point ( Mem->CP_role ) ;
  MyProp->my_offsidekick_point
	  = get_position_my_offsidekick_point ( Mem->CP_role ) ;

  MyProp->offside_line_offset = offside_line_offset_set[Mem->CP_role];
  MyProp->shoot_distance = shoot_distance_set[Mem->CP_role] ;
  MyProp->offside_line_value = offside_line_value[Mem->CP_role] ;

  if ( Mem->CP_role == 1 )
  {
	  change_view ( VW_Narrow ) ;
  }
}

int main(int argc, char* argv[])
{
	CMU_main(argc, argv, my_init);
}
