#include <libCMU.h>
#include <zeng.h>

Vector get_position_beforekickoff ( int num )
{

//temporary
static double pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{-48.0	,  0.0	},/*C  GK*//*1*/

{-15.0	,  0.0	},/*C  DF*//*2*/
{-15.0	,-16.0	},/*L  DF*//*3*/
{-15.0	, 16.0	},/*R  DF*//*4*/

{ -9.0	,  9.0	},/*R  MF*//*5*/
{ -9.0	, -9.0	},/*L  MF*//*6*/

{ -2.0	,-25.0	},/*L SMF*//*7*/
{ -2.0	, 25.0	},/*R SMF*//*8*/

{ -5.0	,  0.0	},/*C  OH*//*9*/
{-10.0	,-16.0	},/*R  FW*//*10*/
{-10.0	, 16.0	},/*L  FW*//*11*/
} ;

	if ( num > 0 && num < 12 )
	{
		return ( Vector ( pos[num][0] , pos[num][1] ) ) ;
	}
	else
	{
		//Error
		return ( Vector ( -10 ,0 ) ) ;
	}
}

Vector get_position_my_freekick_point ( int num )
{

//temporary
static double pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{  0.0	,  0.0	},/*C  GK*//*1*/

{ 30.0	,  0.0	},/*C  DF*//*2*/
{ 30.0	,-25.0	},/*L  DF*//*3*/
{ 30.0	, 25.0	},/*R  DF*//*4*/

{ 25.0	, 18.0	},/*R  MF*//*5*/
{ 25.0	,-18.0	},/*L  MF*//*6*/

{ 20.0	,-25.0	},/*L SMF*//*7*/
{ 20.0	, 25.0	},/*R SMF*//*8*/

{ 35.0	,  0.0	},/*C  OH*//*9*/
{ 35.0	,-16.0	},/*R  FW*//*10*/
{ 35.0	, 16.0	},/*L  FW*//*11*/
} ;

	if ( num > 0 && num < 12 )
	{
		return ( Vector ( pos[num][0] , pos[num][1] ) ) ;
	}
	else
	{
		//Error
		return ( Vector ( 40 ,0 ) ) ;
	}
}

Vector get_position_my_offsidekick_point ( int num )
{

//temporary
static double pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{  0.0	,  0.0	},/*C  GK*//*1*/

{ 15.0	,  0.0	},/*C  DF*//*2*/
{ 15.0	,-25.0	},/*L  DF*//*3*/
{ 15.0	, 25.0	},/*R  DF*//*4*/

{ 20.0	, 15.0	},/*R  MF*//*5*/
{ 20.0	,-15.0	},/*L  MF*//*6*/

{ 15.0	,-25.0	},/*L SMF*//*7*/
{ 15.0	, 25.0	},/*R SMF*//*8*/

{ 30.0	,  0.0	},/*C  OH*//*9*/
{ 30.0	,-16.0	},/*R  FW*//*10*/
{ 30.0	, 16.0	},/*L  FW*//*11*/
} ;

	if ( num > 0 && num < 12 )
	{
		return ( Vector ( pos[num][0] , pos[num][1] ) ) ;
	}
	else
	{
		//Error
		return ( Vector ( 40 ,0 ) ) ;
	}
}

Vector get_position_my_cornerkick_point ( int num )
{

//temporary
static double pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{  0.0	,  0.0	},/*C  GK*//*1*/

{ 36.0	,  0.0	},/*C  DF*//*2*/
{ 36.0	,-18.0	},/*L  DF*//*3*/
{ 36.0	, 18.0	},/*R  DF*//*4*/

{ 40.0	, 18.0	},/*R  MF*//*5*/
{ 40.0	,-18.0	},/*L  MF*//*6*/

{ 40.0	,-25.0	},/*L SMF*//*7*/
{ 40.0	, 25.0	},/*R SMF*//*8*/

{ 40.0	,  0.0	},/*C  OH*//*9*/
{ 35.0	,-16.0	},/*R  FW*//*10*/
{ 35.0	, 16.0	},/*L  FW*//*11*/
} ;

	if ( num > 0 && num < 12 )
	{
		return ( Vector ( pos[num][0] , pos[num][1] ) ) ;
	}
	else
	{
		//Error
		return ( Vector ( 40 ,0 ) ) ;
	}
}

Vector get_position_my_kickoff ( int num )
{
//temporary
static double pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{-48.0	,  0.0	},/*C  GK*//*1*/

{-15.0	,  0.0	},/*C  DF*//*2*/
{-15.0	,-16.0	},/*L  DF*//*3*/
{-15.0	, 16.0	},/*R  DF*//*4*/

{ -9.0	,  9.0	},/*R  MF*//*5*/
{ -9.0	, -9.0	},/*L  MF*//*6*/

{ -2.0	,-25.0	},/*L SMF*//*7*/
{ -2.0	, 25.0	},/*R SMF*//*8*/

{ -5.0	,  0.0	},/*C  OH*//*9*/
{-10.0	,-16.0	},/*R  FW*//*10*/
{-10.0	, 16.0	},/*L  FW*//*11*/
} ;

	if ( num > 0 && num < 12 )
	{
		return ( Vector ( pos[num][0] , pos[num][1] ) ) ;
	}
	else
	{
		//Error
		return ( Vector ( -10 ,0 ) ) ;
	}
}

Vector get_position_their_kickoff ( int num )
{
//temporary
static double pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{-48.0	,  0.0	},/*C  GK*//*1*/

{-16.0	,  0.0	},/*C  DF*//*2*/
{-16.0	,-16.0	},/*L  DF*//*3*/
{-16.0	, 16.0	},/*R  DF*//*4*/

{-11.0	,  9.0	},/*R  MF*//*5*/
{-11.0	, -9.0	},/*L  MF*//*6*/

{-5.0	,-20.0	},/*L SMF*//*7*/
{-5.0	, 20.0	},/*R SMF*//*8*/

{-10.0	,  0.0	},/*C  OH*//*0*/
{-1.0	,-16.0	},/*R  FW*//*0*/
{-1.0	, 16.0	},/*L  FW*//*0*/
} ;

	if ( num > 0 && num < 12 )
	{
		return ( Vector ( pos[num][0] , pos[num][1] ) ) ;
	}
	else
	{
		//Error
		return ( Vector ( -10 ,0 ) ) ;
	}
}

Vector get_position_my_kickin ( int num )
{
//temporary
static double pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{-48.0	,  0.0	},/*C  GK*//*1*/

{-10.0	,  0.0	},/*C  DF*//*2*/
{-10.0	,-16.0	},/*L  DF*//*3*/
{-10.0	, 16.0	},/*R  DF*//*4*/

{ 10.0	, 10.0	},/*R  MF*//*5*/
{ 10.0	,-10.0	},/*L  MF*//*6*/

{ -1.0	,-25.0	},/*L SMF*//*7*/
{ -1.0	, 25.0	},/*R SMF*//*8*/

{ 13.0	,  0.0	},/*C  OH*//*0*/
{ 15.0	,-12.0	},/*R  FW*//*0*/
{ 15.0	, 12.0	},/*L  FW*//*0*/
} ;

	if ( num > 0 && num < 12 )
	{
		return ( Vector ( pos[num][0] , pos[num][1] ) ) ;
	}
	else
	{
		//Error
		return ( Vector ( -10 ,0 ) ) ;
	}
}

Vector get_position_their_kickin ( int num )
{
//temporary
static double pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{-48.0	,  0.0	},/*C  GK*//*1*/

{-12.0	,  0.0	},/*C  DF*//*2*/
{-12.0	,-16.0	},/*L  DF*//*3*/
{-12.0	, 16.0	},/*R  DF*//*4*/

{ 10.0	, 10.0	},/*R  MF*//*5*/
{ 10.0	,-10.0	},/*L  MF*//*6*/

{-10.0	,-25.0	},/*L SMF*//*7*/
{-10.0	, 25.0	},/*R SMF*//*8*/

{ 10.0	,  0.0	},/*C  OH*//*0*/
{ 15.0	,-12.0	},/*R  FW*//*0*/
{ 15.0	, 12.0	},/*L  FW*//*0*/
} ;

	if ( num > 0 && num < 12 )
	{
		return ( Vector ( pos[num][0] , pos[num][1] ) ) ;
	}
	else
	{
		//Error
		return ( Vector ( -10 ,0 ) ) ;
	}
}

Vector get_position_my_freekick ( int num )
{
//temporary
static double pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{-48.0	,  0.0	},/*C  GK*//*1*/

{-12.0	,  0.0	},/*C  DF*//*2*/
{-12.0	,-16.0	},/*L  DF*//*3*/
{-12.0	, 16.0	},/*R  DF*//*4*/

{ 10.0	, 10.0	},/*R  MF*//*5*/
{ 10.0	,-10.0	},/*L  MF*//*6*/

{ -1.0	,-25.0	},/*L SMF*//*7*/
{ -1.0	, 25.0	},/*R SMF*//*8*/

{ 13.0	,  0.0	},/*C  OH*//*9*/
{ 15.0	,-12.0	},/*R  FW*//*10*/
{ 15.0	, 12.0	},/*L  FW*//*11*/
} ;

	if ( num > 0 && num < 12 )
	{
		return ( Vector ( pos[num][0] , pos[num][1] ) ) ;
	}
	else
	{
		//Error
		return ( Vector ( -10 ,0 ) ) ;
	}
}

Vector get_position_their_freekick ( int num )
{
//temporary
static double pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{-48.0	,  0.0	},/*C  GK*//*1*/

{-10.0	,  0.0	},/*C  DF*//*2*/
{-10.0	,-16.0	},/*L  DF*//*3*/
{-10.0	, 16.0	},/*R  DF*//*4*/

{ -5.0	,  9.0	},/*R  MF*//*5*/
{ -5.0	, -9.0	},/*L  MF*//*6*/

{ -1.0	,-25.0	},/*L SMF*//*7*/
{ -1.0	, 25.0	},/*R SMF*//*8*/

{ 5.0	,  0.0	},/*C  OH*//*9*/
{10.0	,-16.0	},/*R  FW*//*10*/
{10.0	, 16.0	},/*L  FW*//*11*/
} ;

	if ( num > 0 && num < 12 )
	{
		return ( Vector ( pos[num][0] , pos[num][1] ) ) ;
	}
	else
	{
		//Error
		return ( Vector ( -10 ,0 ) ) ;
	}
}

Vector get_position_my_offside ( int num )
{
//temporary
static double pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{-48.0	,  0.0	},/*C  GK*//*1*/

{-10.0	,  0.0	},/*C  DF*//*2*/
{-10.0	,-16.0	},/*L  DF*//*3*/
{-10.0	, 16.0	},/*R  DF*//*4*/

{ 8.0	, 10.0	},/*R  MF*//*5*/
{ 8.0	,-10.0	},/*L  MF*//*6*/

{-1.0	,-25.0	},/*L SMF*//*7*/
{-1.0	, 25.0	},/*R SMF*//*8*/

{ 13.0	,  0.0	},/*C  OH*//*0*/
{ 15.0	,-12.0	},/*R  FW*//*0*/
{ 15.0	, 12.0	},/*L  FW*//*0*/
} ;

	if ( num > 0 && num < 12 )
	{
		return ( Vector ( pos[num][0] , pos[num][1] ) ) ;
	}
	else
	{
		//Error
		return ( Vector ( -10 ,0 ) ) ;
	}
}

Vector get_position_their_offside ( int num )
{
//temporary
static double pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{-48.0	,  0.0	},/*C  GK*//*1*/

{-12.0	,  0.0	},/*C  DF*//*2*/
{-12.0	,-16.0	},/*L  DF*//*3*/
{-12.0	, 16.0	},/*R  DF*//*4*/

{  -5.0	,  9.0	},/*R  MF*//*5*/
{  -5.0	, -9.0	},/*L  MF*//*6*/

{  8.0	,-25.0	},/*L SMF*//*7*/
{  8.0	, 25.0	},/*R SMF*//*8*/

{ 5.0	,  0.0	},/*C  OH*//*9*/
{10.0	,-16.0	},/*R  FW*//*10*/
{10.0	, 16.0	},/*L  FW*//*11*/

} ;

	if ( num > 0 && num < 12 )
	{
		return ( Vector ( pos[num][0] , pos[num][1] ) ) ;
	}
	else
	{
		//Error
		return ( Vector ( -10 ,0 ) ) ;
	}
}

Vector get_position_my_cornerkick ( int num )
{
//temporary
static double pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{-48.0	,  0.0	},/*C  GK*//*1*/

{-5.0	,  0.0	},/*C  DF*//*2*/
{-5.0	,-16.0	},/*L  DF*//*3*/
{-5.0	, 16.0	},/*R  DF*//*4*/

{ 15.0	, 10.0	},/*R  MF*//*5*/
{ 15.0	,-10.0	},/*L  MF*//*6*/

{ 36.0	,-30.0	},/*L SMF*//*7*/
{ 36.0	, 30.0	},/*R SMF*//*8*/

{ 35.0	,  0.0	},/*C  OH*//*0*/
{ 35.0	,-12.0	},/*R  FW*//*0*/
{ 35.0	, 12.0	},/*L  FW*//*0*/
} ;

	if ( num > 0 && num < 12 )
	{
		return ( Vector ( pos[num][0] , pos[num][1] ) ) ;
	}
	else
	{
		//Error
		return ( Vector ( -10 ,0 ) ) ;
	}
}

Vector get_position_their_cornerkick ( int num )
{
//temporary
static double pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{-48.0	,  0.0	},/*C  GK*//*1*/

{-40.0	,  0.0	},/*C  DF*//*2*/
{-40.0	,-16.0	},/*L  DF*//*3*/
{-40.0	, 16.0	},/*R  DF*//*4*/

{ -20.0	,  9.0	},/*R  MF*//*5*/
{ -20.0	, -9.0	},/*L  MF*//*6*/

{ -10.0	,-25.0	},/*L SMF*//*7*/
{ -10.0	, 25.0	},/*R SMF*//*8*/

{ -5.0	,  0.0	},/*C  OH*//*9*/
{-10.0	,-16.0	},/*R  FW*//*10*/
{-10.0	, 16.0	},/*L  FW*//*11*/
} ;

	if ( num > 0 && num < 12 )
	{
		return ( Vector ( pos[num][0] , pos[num][1] ) ) ;
	}
	else
	{
		//Error
		return ( Vector ( -10 ,0 ) ) ;
	}
}

Vector get_position_my_goalkick ( int num )
{
//temporary
static double pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{-48.0	,  0.0	},/*C  GK*//*1*/

{-10.0	,  0.0	},/*C  DF*//*2*/
{-10.0	,-16.0	},/*L  DF*//*3*/
{-10.0	, 16.0	},/*R  DF*//*4*/

{ 10.0	, 10.0	},/*R  MF*//*5*/
{ 10.0	,-10.0	},/*L  MF*//*6*/

{-10.0	,-25.0	},/*L SMF*//*7*/
{-10.0	, 25.0	},/*R SMF*//*8*/

{ 13.0	,  0.0	},/*C  OH*//*0*/
{ 15.0	,-12.0	},/*R  FW*//*0*/
{ 15.0	, 12.0	},/*L  FW*//*0*/
} ;

	if ( num > 0 && num < 12 )
	{
		return ( Vector ( pos[num][0] , pos[num][1] ) ) ;
	}
	else
	{
		//Error
		return ( Vector ( -10 ,0 ) ) ;
	}
}

Vector get_position_their_goalkick ( int num )
{
//temporary
static double pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{-48.0	,  0.0	},/*C  GK*//*1*/

{-5.0	,  0.0	},/*C  DF*//*2*/
{-5.0	,-16.0	},/*L  DF*//*3*/
{-5.0	, 16.0	},/*R  DF*//*4*/

{ 12.0	,  9.0	},/*R  MF*//*5*/
{ 12.0	, -9.0	},/*L  MF*//*6*/

{ 23.0	,-25.0	},/*L SMF*//*7*/
{ 23.0	, 25.0	},/*R SMF*//*8*/

{ 30.0	,  0.0	},/*C  OH*//*9*/
{ 30.0	,-16.0	},/*R  FW*//*10*/
{ 30.0	, 16.0	},/*L  FW*//*11*/
} ;

	if ( num > 0 && num < 12 )
	{
		return ( Vector ( pos[num][0] , pos[num][1] ) ) ;
	}
	else
	{
		//Error
		return ( Vector ( -10 ,0 ) ) ;
	}
}


Vector get_position_dribble1 ( int num )
{
//temporary
static double pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{-35.0	,  0.0	},/*C  GK*//*1*/

{-5.0	,  0.0	},/*C  DF*//*2*/
{-5.0	,-16.0	},/*L  DF*//*3*/
{-5.0	, 16.0	},/*R  DF*//*4*/

{ 12.0	,  9.0	},/*R  MF*//*5*/
{ 12.0	, -9.0	},/*L  MF*//*6*/

{ 40.0	,-30.0	},/*L SMF*//*7*/
{ 40.0	, 30.0	},/*R SMF*//*8*/

{ 30.0	,  0.0	},/*C  OH*//*9*/
{ 30.0	,-16.0	},/*R  FW*//*10*/
{ 30.0	, 16.0	},/*L  FW*//*11*/
} ;

	if ( num > 0 && num < 12 )
	{
		return ( Vector ( pos[num][0] , pos[num][1] ) ) ;
	}
	else
	{
		//Error
		return ( Vector ( -10 ,0 ) ) ;
	}
}


Vector get_position_dribble2 ( int num )
{
//temporary
static double pos[12][2] = {
{  0.0	,  0.0	},/*dummy*//*0*/
{-48.0	,  0.0	},/*C  GK*//*1*/

{-5.0	,  0.0	},/*C  DF*//*2*/
{-5.0	,-16.0	},/*L  DF*//*3*/
{-5.0	, 16.0	},/*R  DF*//*4*/

{ 12.0	,  9.0	},/*R  MF*//*5*/
{ 12.0	, -9.0	},/*L  MF*//*6*/

{ 23.0	,-25.0	},/*L SMF*//*7*/
{ 23.0	, 25.0	},/*R SMF*//*8*/

{ 30.0	,  0.0	},/*C  OH*//*9*/
{ 30.0	,-16.0	},/*R  FW*//*10*/
{ 30.0	, 16.0	},/*L  FW*//*11*/
} ;

	if ( num > 0 && num < 12 )
	{
		return ( Vector ( pos[num][0] , pos[num][1] ) ) ;
	}
	else
	{
		//Error
		return ( Vector ( -10 ,0 ) ) ;
	}
}
