#include <libCMU.h>
#include <zeng.h>

double minimal_buffer()
{
	double res = 0 ;
	switch (Mem->PlayMode) {
		case PM_Their_Kick_Off:
		case PM_Their_Corner_Kick:
		case PM_Their_Goal_Kick:
		case PM_Their_Free_Kick:
		case PM_Their_Offside_Kick:
			res = Mem->SP_free_kick_buffer + 1;
			break;
		default:
			res = 0;
	}
	return res;
}

//temporary function
double  get_danger_val_player ( float dist )
{
	double danger_val = 0 ;

	if ( dist <= 3.0 )
	{
		danger_val = 1.0  ;
	}
	else if ( dist >= 20.0 )
	{
		danger_val = 0.0 ;
	}
	else if ( dist <= 5.0 )
	{
		danger_val = 0.6 ;
	}
	else if ( dist <= 10.0 )
	{
		danger_val = 0.3 ;
	}
	else if ( dist <= 15.0 )
	{
		danger_val = 0.1 ;
	}
	else
	{
		danger_val = 0.05 ;
	}

	return ( danger_val );
}

//temporary function
double get_danger_val ( double dist )
{
	double value = 0 ;

	for (Unum e = 1; e <= 11; e++)
	{
		if (Mem->OpponentPositionValid(e)>0.9)
		{
			if ( Mem->OpponentDistance(e) < dist ) {
				value += get_danger_val_player(Mem->OpponentDistance(e)) ;
			}
		}
	}

	for (Unum e = 0; e < Mem->NumTeamlessPlayers(); e++)
	{
		if (Mem->DistanceTo(Mem->TeamlessPlayers()[e]->get_abs_pos()) < dist )
		{
			value += get_danger_val_player( Mem->DistanceTo( Mem->TeamlessPlayers()[e]->get_abs_pos() ) ) ;
		}
	}

	return ( value ) ;
}


int how_many_closer_teammate(Vector v)
{
	Unum teammate[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11};

	int n = Mem->SortPlayersByDistanceToPoint('m', v, teammate);
	int i = 0;

	for (i = 0; i < n; i++){
		if (teammate[i] == Mem->MyNumber)
			break;
	}

	return i;
}

  /////////////////
 /*		*/
/////////////////
Bool kick_to_xy ( Vector pos )
{
	if ( Mem->BallPositionValid() )
	{
#ifdef CMU99
		return ( kick_to ( (pos - Mem->BallAbsolutePosition()).rotate( - Mem->MyNeckGlobalAng() ) ) )  ;
#else
		return ( kick_to ( (pos - Mem->BallAbsolutePosition()).rotate( - Mem->MyAng() ) ) )  ;
#endif
	}
	else
	{
		return ( FALSE ) ;
	}
}

Bool kick_to ( Vector pos )
{
	float power ;

	if ( ( ! Mem->BallPositionValid() ) || ( ! Mem->BallKickable() ) )
	{
		return ( FALSE ) ;
	}

	power =  pos.mod() * ( 1.0 - Mem->SP_ball_decay ) /
		( Mem->BallKickRate() *
#ifdef CMU99
		  ( 1.0 - 0.25 * ( Mem->BallAngleFromBody() / 180.0 )
#else
		  ( 1.0 - 0.25 * ( Mem->BallAngle() / 180.0 )
#endif
		    - 0.25 * (( Mem->BallDistance() - Mem->SP_player_size - Mem->SP_ball_size )
			      / (Mem->SP_kickable_area )))) ;

	if ( power > Mem->SP_max_power )
		power = Mem->SP_max_power ;
	if ( power < Mem->SP_min_power )
		power = Mem->SP_min_power ;

	Vector addpower = Polar2Vector ( power, pos.dir() ) ;

	if ( Mem->BallVelocityValid() )
	{
		pos = addpower - Mem->BallAbsoluteVelocity() ;
	}

	kick ( pos.mod() , pos.dir()) ;

	return ( TRUE ) ;
}


//////////
//Aoyagi//
//////////
//--------------------------------------
//    ܡ뤬ʬ˸äƤ뤫
//--------------------------------------
Bool ball_to_my(float buffer)
{
//	if(Mem->BallRelativeVelocity().x > 0 && 
//	   Mem->BallRelativeVelocity().y > 0){
//		return FALSE;
//	}

	Vector pos = Mem->MyPos();
	return ball_to_point(pos,buffer);
}

//--------------------------------------
//    ܡ뤬ݥȤ˸äƤ뤫
//--------------------------------------
Bool ball_to_point(Vector point, float buffer)
{
	Vector ball = Mem->BallAbsolutePosition();
	Vector ballvel = Mem->BallAbsoluteVelocity();

	//ܡ뤬ưƤʤʤFALSE
	if(ballvel.x == 0 && ballvel.y == 0){
		return FALSE;
	}
	// ܡư狼ʤʤFALSE
	if(!Mem->BallVelocityValid()){
		return FALSE;
	}

	// ܡ뤬ݥȤΥƹԤʤFALSE
	if(ballvel.x < 0 && (ball.x - point.x) < 0)
		return FALSE;
	if(ballvel.x > 0 && (ball.x - point.x) > 0)
		return FALSE;
	if(ballvel.y < 0 && (ball.y - point.y) < 0)
		return FALSE;
	if(ballvel.y > 0 && (ball.y - point.y) > 0)
		return FALSE;

	Vector psol1, psol2;  // 

#ifdef CMU99
	Line l ;
	l.LineFromRay(ball,ballvel) ;
	return 
	((LineCircleIntersect(l, buffer, point, &psol1, &psol2) >= 1)
			? TRUE : FALSE);
#else
	return 
	((RayCircleIntersect(ball, ballvel, buffer, point, &psol1, &psol2) >= 1)
			? TRUE : FALSE);
#endif
}

Bool player_is_dribble ( void )
{
	//tmp

	if ( Mem->BallPositionValid() )
	{
		if ( Mem->BallVelocityValid() )
		{
			if ( Mem->BallSpeed() < 0.65 && Mem->PlayerWithBall ( - 0.5 ) > 0 && Mem->PlayerWithBall() != Mem->MyNumber )
			{
				return TRUE ;
			}
		}
		else
		{
			if ( Mem->PlayerWithBall ( - 0.5 ) > 0 && Mem->PlayerWithBall() != Mem->MyNumber )
			{
				return TRUE ;
			}
		}
	}
	else
	{
		return FALSE ;
	}
}

